

#include <iostream.h>
#include <fstream.h>
#include <string.h>
#include <stdio.h>
#include <io.h>

unsigned char positions[220];
unsigned char songlength;
unsigned char loopposition;
unsigned char stereo[24];
unsigned char tempo;
unsigned char basefreq;
unsigned char detune[24];
unsigned char modulation[48];
unsigned char startwaves[24];
unsigned char waves[48];
unsigned char volumes[48];
unsigned char songname[50];
unsigned char wavekit[8];
unsigned short offsets[80+1];
unsigned short extoffset;
unsigned char extdat;
unsigned char *patterndata;
unsigned char lfodata[25];

unsigned char highestpattern = 0;


int write(char *filename)
{
ofstream output;
char *userid = "MBMS\x010\x008";

	output.open(filename, ios::out | ios::binary); 
	output.write(userid, 6);
	output.write(&songlength, 1);
	output.write(&loopposition,1);
	output.write(stereo, 24);
	output.write(&tempo, 1);
	output.write(&basefreq, 1);
	output.write(detune,24);
	output.write(modulation, 48);
	output.write(startwaves, 24);
	output.write(waves, 48);
	output.write(volumes, 48);
	output.write(songname, 50);
	output.write(wavekit, 8);

	for (int c = 0; c < (songlength + 1); c++)
		output.write(&positions[c], 1);

	for (c = 0; c < highestpattern; c++)
	{
		short offset = offsets[c] - offsets[0]
					+ 1 + 1 + 24 + 1 + 1 + 24 + 48 + 24 + 48 + 48 + 50 + 8
					+ (songlength + 1) + 2 * highestpattern;

		output.write((char*)&offset, 2);
	}

	short length = offsets[highestpattern] - offsets[0];
	output.write((char*)&length, 2);
	output.write(&highestpattern, 1);

	for (c = 0; c < highestpattern; c++)
	{
		short length = offsets[c+1] - offsets[c];

		output.write(&patterndata[offsets[c]-offsets[0]], length);
	}

	output.write(lfodata, 25);

	output.close();

	return 0;
}

int read(char *filename)
{
ifstream input;
char *editid = "MBMS\x010\x007";
char *userid = "MBMS\x010\x008";
char id[6];

	input.open( filename, ios::in | ios::binary );
	input.read(id, 6);

	if (memcmp(id, userid, 6) == 0)
	{
		cout << filename << " is already a USER file!" << endl;
		return 1;
	}

	if (memcmp(id, editid, 6) != 0)
	{
		cout << filename << " is not a valid MWM file!" << endl;
		return 1;
	}

	input.read(positions, 220);	//read position data
	input.read(&songlength, 1);
	input.read(&loopposition, 1);
	input.read(stereo, 24);
	input.read(&tempo, 1);
	input.read(&basefreq, 1);
	input.read(detune, 24);
	input.read(modulation, 48);
	input.read(startwaves, 24);
	input.read(waves, 48);
	input.read(volumes, 48);
	input.read(songname, 50);
	input.read(wavekit, 8);
	input.read((char*)offsets, 160);
	input.read((char*)&extoffset, 2);
	input.read(&extdat, 1);

	patterndata = new unsigned char[extoffset];
	input.read(patterndata, extoffset);

	input.read(lfodata, 25);

	input.close();

	highestpattern = 0;

	for (int c = 0; c < (songlength + 1); c++)
	{
		if (positions[c] > highestpattern)
			highestpattern = positions[c];
	}

	highestpattern++;
	
	offsets[80] = extoffset + offsets[0];

	return 0;
}



int main(int argc, char *argv[])
{
_finddata_t search_result;
long file_handle;

	//give an error message if no arguments supplied
	if (argc == 1)
	{
		cout << "No files to convert!!";

		return 0;
	}

	//search for first file matching argument
	file_handle = _findfirst(argv[1], &search_result);

	//if no results
	if ( file_handle == -1L)
	{	//display message
		cout << "File " << argv[1] << " not found!" << endl;
	}
	else
	{	//convert file if it's not a subdirectory
		if ( !(search_result.attrib & _A_SUBDIR))
		{
			if (!read(search_result.name))
			{
				write(search_result.name);
				cout << search_result.name << " has been converted!" << endl;

				delete patterndata;
			}
		}

		//search more files
		while (_findnext(file_handle, &search_result) == 0)
		{	//and convert only if not subdirectory
			if ( !(search_result.attrib & _A_SUBDIR) )
			{
				if (!read(search_result.name))
				{
					write(search_result.name);
					cout << search_result.name << " has been converted!" << endl;
					
					delete patterndata;
				}
			}
		}
	}

	//release resources used by search
	_findclose(file_handle);

	return 0;
}